Syncfusion AI Assistant

How can I help you?

Context menu in EJ2 JavaScript Gantt control

2 Apr 202612 minutes to read

The Gantt control allows you to perform quick actions by using context menu. When right-clicking the context menu, the context menu options are shown. To enable this feature, set the enableContextMenu to true. The default context menu options are enabled using the editSettings property. The context menu options can be customized using the contextMenuItems property.

To use the context menu, inject the ContextMenu module into the Gantt control.

The default items are listed in the following table.

Items Description
AutoFit Auto-fits the current column.
AutoFitAll Auto-fits all columns.
SortAscending Sorts the current column in ascending order.
SortDescending Sorts the current column in descending order.
TaskInformation Edits the current task.
Add Adds a new row to the Gantt.
Indent Indent the selected record to one level.
Outdent Outdent the selected record to one level.
DeleteTask Deletes the current task.
Save Saves the edited task.
Cancel Cancels the edited task.
DeleteDependency Deletes the current dependency task link.
Convert Converts current task to milestone or vice-versa.
var ganttChart = new ej.gantt.Gantt({
        dataSource: GanttData,
		height:'450px',
		taskFields: {
            id: 'TaskID',
        	name: 'TaskName',
        	startDate: 'StartDate',
        	dependency: 'Predecessor',
        	duration: 'Duration',
        	progress: 'Progress',
        	child: 'subtasks'
        },
		allowSorting: true,
		allowResizing: true,
		editSettings:{
			allowAdding: true,
			allowEditing: true,
			allowDeleting: true,
			allowTaskbarEditing: true
		},
		enableContextMenu: true
});
ganttChart.appendTo('#ContextMenu');
<!DOCTYPE html><html lang="en"><head>
     <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
	<link href="https://cdn.syncfusion.com/ej2/33.2.3/tailwind3.css" rel="stylesheet" type="text/css">
    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
       
     
    <div id="container">	   
        <div id="ContextMenu"></div>        
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Custom context menu items

The custom context menu items can be added by defining the contextMenuItems as a collection of contextMenuItemModel. Actions for the customized items can be defined in the contextMenuClick event and the visibility of customized items can be defined in the contextMenuOpen event.

To create custom context menu items for header area, define the target property as .e-gridheader.

The following sample shows context menu item for parent rows to expand or collapse child rows in the content area and a context menu item to hide columns in the header area.

var ganttChart = new ej.gantt.Gantt({
        dataSource: GanttData,
		height:'450px',
		taskFields: {
            id: 'TaskID',
        	name: 'TaskName',
        	startDate: 'StartDate',
        	dependency: 'Predecessor',
        	duration: 'Duration',
        	progress: 'Progress',
        	parentID: 'ParentID'
        },
        allowSorting: true,
        allowResizing: true,
		editSettings:{
			allowAdding: true,
			allowEditing: true,
			allowDeleting: true,
			allowTaskbarEditing: true
		},
        enableContextMenu: true,
        contextMenuItems: ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel',
            'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
            { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
            { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
			{ text: 'Hide Column', target: '.e-gridheader', id: 'hidecols' }
        ],
        contextMenuClick: function (args) {
            var record = args.rowData;
            if (args.item.id === 'collapserow') {
                ganttChart.collapseByID(Number(record.ganttProperties.taskId));
            }
            if (args.item.id === 'expandrow') {
                ganttChart.expandByID(Number(record.ganttProperties.taskId));
            }
            if (args.item.id === 'hidecols') {
                ganttChart.hideColumn(args.column.headerText);
            }
        },
        contextMenuOpen: function (args) {
            var record = args.rowData;
            if (args.type !== 'Header') {
                if (!record.hasChildRecords) {
                    args.hideItems.push('Collapse the Row');
                    args.hideItems.push('Expand the Row');
                } else {
                    if(record.expanded){
                        args.hideItems.push("Expand the Row");                        
                    } else {
                        args.hideItems.push("Collapse the Row");
                    }
                }
            }
        }
});
ganttChart.appendTo('#CustomContextMenu');
<!DOCTYPE html>
<html lang="en">
    <head>
        <title>EJ2 Gantt</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="Typescript Gantt Controls">
        <meta name="author" content="Syncfusion">
        <link href="index.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.2.3/tailwind3.css" rel="stylesheet" type="text/css">
        <script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
        <script src="es5-datasource.js" type="text/javascript"></script>
    </head>

    <body> 
        <div id="container">	   
            <div id="CustomContextMenu"></div>        
        </div>
        <script>
        var ele = document.getElementById('container');
            if(ele) {
            ele.style.visibility = "visible";
            }   
        </script>
        <script src="index.js" type="text/javascript"></script>
    </body>
</html>

You can show an specific item in context menu for header/content area in the Gantt control by defining the target property.

Touch interaction

To perform long press action on a row, context menu is opened, and then tap a menu item to trigger its action.

Syncfusion AI Assistant

How can I help you?

Context Menu in Angular Gantt Chart Component

1 Feb 202615 minutes to read

The context menu in the Syncfusion Angular Gantt Chart component provides right-click access to task and column operations, improving efficiency with contextual task actions. Menu items adapt based on the clicked element, such as task rows, column headers, or chart areas.

Enabling context menu

To enable the context menu, set the enableContextMenu property to true and import ContextMenuService from @syncfusion/ej2-angular-gantt in the providers of the component.

The following items are available in the default context menu:

  • AutoFit: Adjusts the current column width to fit its content.
  • AutoFitAll: Adjusts all column widths to fit their content.
  • SortAscending: Sorts the current column in ascending order.
  • SortDescending: Sorts the current column in descending order.
  • TaskInformation: Opens the editing dialog for the selected task.
  • Add: Inserts a new task with sub-options: Above, Below, Child, Milestone.
  • Indent: Moves the selected task one level inward.
  • Outdent: Moves the selected task one level outward.
  • DeleteTask: Deletes the selected task.
  • Save: Commits changes to the edited task.
  • Cancel: Discards changes to the edited task.
  • SplitTask: Divides the selected task at the specified date.
  • MergeTask: Combines split task segments with sub-options: Left, Right.
  • Convert: Converts tasks with sub-options: To Milestone and To Task.
  • DeleteDependency: Deletes the selected task dependency.

The following example demonstrates context menu implementation with default items, where menu options adapt based on the clicked element and editSettings configuration.

import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { GanttModule, ContextMenuService, EditService,SelectionService, SortService, ResizeService } from '@syncfusion/ej2-angular-gantt'

@Component({
    imports: [GanttModule],
    providers: [SelectionService, ContextMenuService, EditService, SortService, ResizeService],
    standalone: true,
    selector: 'app-root',
    template:
        `<ejs-gantt height="430px" [dataSource]="data" [taskFields]="taskSettings" [enableContextMenu]="true" [allowSorting]="true" [allowResizing]="true" [editSettings]="editSettings">
        </ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    public data?: object[];
    public taskSettings?: object;
    public editSettings?: object;
    public ngOnInit(): void {
        this.data = [
            { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'), },
            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
            { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'), },
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
            { TaskID: 9, TaskName: 'Sign Contract', StartDate: new Date('04/04/2019'), Duration: 1, Predecessor: '8', Progress: 30 },
            { TaskID: 10, TaskName: 'Project Approval and kick off', StartDate: new Date('04/04/2019'), EndDate: new Date('04/21/2019'), Duration: 0, Predecessor: '9' },
        ];
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            parentID: 'ParentID'
        };
        this.editSettings = {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true
        };
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

If a required feature is not enabled, the related context menu item will be disabled or hidden to prevent unsupported actions.

Custom context menu items

Extend the context menu functionality by adding custom items using the contextMenuItems property. Custom items are defined as a collection of contextMenuItemModel objects with properties for id (unique identifier), text (display label), target (CSS selector for appearance context), and iconCss (icon styling class).

The target property determines where custom menu items appear: .e-content for task-related operations, like add, delete, save, and cancel, .e-gridheader for column-related operations.

The contextMenuOpen event enables dynamic modification, such as hiding items based on row selection. The contextMenuClick event handles custom item actions, providing details like the selected item’s id, text, and row data.

The following sample shows context menu items for parent rows to expand or collapse child rows in the content area and a context menu item to hide columns in the header area.

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { GanttModule, SortService, ResizeService, GanttComponent, ContextMenuClickEventArgs, ContextMenuOpenEventArgs, SelectionService, ContextMenuService, EditService } from '@syncfusion/ej2-angular-gantt'
import { ContextMenuItemModel } from '@syncfusion/ej2-angular-grids';

@Component({
  imports: [GanttModule],
  providers: [SelectionService, ContextMenuService, EditService, SortService, ResizeService],
  standalone: true,
  selector: 'app-root',
  template:
    `<ejs-gantt #customcontextmenu height="430px" [dataSource]="data" [taskFields]="taskSettings" [enableContextMenu]="true" [contextMenuItems]="contextMenuItems" [allowSorting]="true" [allowResizing]="true" [editSettings]="editSettings" (contextMenuClick)="contextMenuClick($event)" (contextMenuOpen)="contextMenuOpen($event)"></ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  @ViewChild('customcontextmenu', { static: true }) public ganttInstance?: GanttComponent;
  public data?: object[];
  public taskSettings?: object;
  public editSettings?: object;
  public contextMenuItems?: (string | ContextMenuItemModel)[];

  public ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      {
        TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 9, TaskName: 'Sign Contract', StartDate: new Date('04/04/2019'), Duration: 1, Predecessor: '8', Progress: 30 },
      {
        TaskID: 10, TaskName: 'Project Approval and kick off', StartDate: new Date('04/04/2019'),
        EndDate: new Date('04/21/2019'), Duration: 0, Predecessor: '9'
      },
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.editSettings = {
      allowAdding: true,
      allowEditing: true,
      allowDeleting: true
    };
    this.contextMenuItems = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
      { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' } as ContextMenuItemModel,
      { text: 'Expand the Row', target: '.e-content', id: 'expandrow' } as ContextMenuItemModel,
      { text: 'Hide Column', target: '.e-gridheader', id: 'hidecols' } as ContextMenuItemModel
    ];
  }

  public contextMenuClick(args: ContextMenuClickEventArgs) {
    let record = args.rowData;
    if (args.item.id === 'collapserow') {
      (this.ganttInstance as GanttComponent).collapseByID(Number(record!.ganttProperties!.taskId));
    }
    if (args.item.id === 'expandrow') {
      (this.ganttInstance as GanttComponent).expandByID(Number(record!.ganttProperties!.taskId));
    }
    if (args.item.id === 'hidecols') {
      (this.ganttInstance as GanttComponent).hideColumn(args.column!.headerText);
    }
  }
  public contextMenuOpen(args: ContextMenuOpenEventArgs) {
    let record = args.rowData;
    if (args.type !== 'Header') {
      if (!record!.hasChildRecords) {
        args.hideItems!.push('Collapse the Row');
        args.hideItems!.push('Expand the Row');
      } else {
        if (record!.expanded) {
          args.hideItems!.push("Expand the Row");
        } else {
          args.hideItems!.push("Collapse the Row");
        }
      }
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

This implementation shows custom context menu integration with event handling. The contextMenuClick event receives parameters including the selected item’s id, text, and the current row data, enabling specific actions based on the context.

Touch interaction

On touch devices, context menu functionality is accessible through long press gestures. Long press on task rows, headers, or chart areas opens the context menu, while tapping menu items executes associated actions. Items with sub-menus (e.g., Add, Convert) expand additional options when tapped, and tapping outside the menu closes it without performing actions.

This touch interaction ensures consistent experience across different device types and input methods while maintaining full functionality through intuitive gesture-based navigation.

For a comprehensive demonstration of context menu functionality, including default items, custom items, and sub-menus, explore the interactive sample.

Syncfusion AI Assistant

How can I help you?

Context Menu in React Gantt Chart Component

24 Mar 202614 minutes to read

The context menu in the Syncfusion React Gantt Chart component provides right-click access to task and column operations, improving efficiency with contextual task actions. Menu items adapt based on the clicked element, such as task rows, column headers, or chart areas.

Enabling context menu

To enable the context menu, set the enableContextMenu property to true and import ContextMenu service from @syncfusion/ej2-react-gantt in the providers of the component.

The following items are available in the default context menu:

  • AutoFit: Adjusts the current column width to fit its content.
  • AutoFitAll: Adjusts all column widths to fit their content.
  • SortAscending: Sorts the current column in ascending order.
  • SortDescending: Sorts the current column in descending order.
  • TaskInformation: Opens the editing dialog for the selected task.
  • Add: Inserts a new task with sub-options: Above, Below, Child, Milestone.
  • Indent: Moves the selected task one level inward.
  • Outdent: Moves the selected task one level outward.
  • DeleteTask: Deletes the selected task.
  • Save: Commits changes to the edited task.
  • Cancel: Discards changes to the edited task.
  • SplitTask: Divides the selected task at the specified date.
  • MergeTask: Combines split task segments with sub-options: Left, Right.
  • Convert: Converts tasks with sub-options: To Milestone and To Task.
  • DeleteDependency: Deletes the selected task dependency.

The following example demonstrates context menu implementation with default items, where menu options adapt based on the clicked element and editSettings configuration.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Selection, ContextMenu, Edit, Sort, Resize } from "@syncfusion/ej2-react-gantt";

import { data } from "./datasource";

function App() {

    const taskSettings = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        progress: "Progress",
        dependency: "Predecessor",
        parentID: "ParentID"
    };

    const editSettings = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
    };

    return (
        <GanttComponent
            height="430px"
            dataSource={data}
            taskFields={taskSettings}
            enableContextMenu={true}
            allowSorting={true}
            allowResizing={true}
            editSettings={editSettings}
        >
            <Inject services={[Selection, ContextMenu, Edit, Sort, Resize]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Selection, ContextMenu, Edit, Sort, Resize, TaskFieldsModel, EditSettingsModel } from "@syncfusion/ej2-react-gantt";

import { data } from "./datasource";

function App() {

    const taskSettings: TaskFieldsModel = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        duration: "Duration",
        progress: "Progress",
        dependency: "Predecessor",
        parentID: "ParentID"
    };

    const editSettings: EditSettingsModel = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
    };

    return (
        <GanttComponent
            height="430px"
            dataSource={data}
            taskFields={taskSettings}
            enableContextMenu={true}
            allowSorting={true}
            allowResizing={true}
            editSettings={editSettings}
        >
            <Inject services={[Selection, ContextMenu, Edit, Sort, Resize]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

If a required feature is not enabled, the related context menu item will be disabled or hidden to prevent unsupported actions.

Custom context menu items

Extend the context menu functionality by adding custom items using the contextMenuItems property. Custom items are defined as a collection of contextMenuItemModel objects with properties for id (unique identifier), text (display label), target (CSS selector for appearance context), and iconCss (icon styling class).

The target property determines where custom menu items appear: .e-content for task-related operations, like add, delete, save, and cancel, .e-gridheader for column-related operations.

The contextMenuOpen event enables dynamic modification, such as hiding items based on row selection. The contextMenuClick event handles custom item actions, providing details like the selected item’s id, text, and row data.

The following sample shows context menu items for parent rows to expand or collapse child rows in the content area and a context menu item to hide columns in the header area.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit, ContextMenu, Selection, Sort, Resize, Toolbar } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';
function App() {
    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const editOptions = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
    };
    const toolbarOptions = ['Add'];
    return <GanttComponent dataSource={data} taskFields={taskFields} allowSelection={true} editSettings={editOptions} enableContextMenu={true} toolbar={toolbarOptions} height='450px'>
        <Inject services={[Edit, ContextMenu, Selection, Sort, Resize, Toolbar]} />
    </GanttComponent>;
};
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit, ContextMenu, Selection, Sort, Resize, Toolbar } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';
function App() {
    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const editOptions = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
    };
    const toolbarOptions = ['Add'];
    return <GanttComponent dataSource={data} taskFields={taskFields} allowSelection={true} editSettings={editOptions} enableContextMenu={true} toolbar={toolbarOptions} height='450px'>
        <Inject services={[Edit, ContextMenu, Selection, Sort, Resize, Toolbar]} />
    </GanttComponent>;
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

This implementation shows custom context menu integration with event handling. The contextMenuClick event receives parameters including the selected item’s id, text, and the current row data, enabling specific actions based on the context.

Touch interaction

On touch devices, context menu functionality is accessible through long press gestures. Long press on task rows, headers, or chart areas opens the context menu, while tapping menu items executes associated actions. Items with sub-menus (e.g., Add, Convert) expand additional options when tapped, and tapping outside the menu closes it without performing actions.

This touch interaction ensures consistent experience across different device types and input methods while maintaining full functionality through intuitive gesture-based navigation.

For a comprehensive demonstration of context menu functionality, including default items, custom items, and sub-menus, explore the interactive sample.

Syncfusion AI Assistant

How can I help you?

Context Menu in Vue Gantt Chart Component

3 Feb 202617 minutes to read

The Gantt Chart component allows you to perform quick actions by using context menu. When right-clicking the context menu, the context menu options are shown. To enable this feature, set the enableContextMenu to true. The default context menu options are enabled using the editSettings property. The context menu options can be customized using the contextMenuItems property.

To use the context menu, inject the ContextMenu module in the provide section.

The default items are listed in the following table.

Items Description
AutoFit Auto-fits the current column.
AutoFitAll Auto-fits all columns.
SortAscending Sorts the current column in ascending order.
SortDescending Sorts the current column in descending order.
TaskInformation Edits the current task.
Add Adds a new row to the Gantt.
Indent Indent the selected record to one level.
Outdent Outdent the selected record to one level.
DeleteTask Deletes the current task.
Save Saves the edited task.
Cancel Cancels the edited task.
DeleteDependency Deletes the current dependency task link.
Convert Converts current task to milestone or vice-versa.
<template>
  <div>
    <ejs-gantt ref='gantt' id="contextMenu" :dataSource="data" :taskFields="taskFields" :height="height"
      :editSettings="editSettings" :enableContextMenu="true" :allowSorting="true" :allowResizing="true"></ejs-gantt>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, ContextMenu, Edit, Sort, Resize, Selection } from "@syncfusion/ej2-vue-gantt";
import { editingData } from './data-source.js';
const data = editingData;
const height = '450px';
const taskFields = {
  id: 'TaskID',
  name: 'TaskName',
  startDate: 'StartDate',
  duration: 'Duration',
  progress: 'Progress',
  dependency: 'Predecessor',
  child: 'subtasks'
};
const editSettings = {
  allowAdding: true,
  allowEditing: true,
  allowDeleting: true
};
provide('gantt', [ContextMenu, Edit, Sort, Resize, Selection]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="contextMenu" :dataSource="data" :taskFields = "taskFields" :height = "height" :editSettings="editSettings" :enableContextMenu="true" :allowSorting="true" :allowResizing= "true"></ejs-gantt>
    </div>
</template>
<script>
import { GanttComponent, ContextMenu, Edit, Sort, Resize, Selection } from "@syncfusion/ej2-vue-gantt";
import { editingData } from './data-source.js';
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
        data: editingData,
        height: '450px',
        taskFields: {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            child: 'subtasks'
        },
        editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
        }
    };
  },
  provide: {
      gantt: [ ContextMenu, Edit, Sort, Resize, Selection]
  }
};
</script>

Custom context menu items

The custom context menu items can be added by defining the contextMenuItems as a collection of contextMenuItemModel.Actions for the customized items can be defined in the contextMenuClick event and the visibility of customized items can be defined in the contextMenuOpen event.

To create custom context menu items for header area, define the target property as .e-gridheader.

The following sample shows context menu item for parent rows to expand or collapse child rows in the content area and a context menu item to hide columns in the header area.

<template>
    <div>
        <ejs-gantt ref='gantt' id="customContextMenu" :dataSource="data" :taskFields="taskFields" :height="height"
            :editSettings="editSettings" :enableContextMenu="true" :allowSorting="true" :allowResizing="true"
            :contextMenuItems="contextMenuItems" :contextMenuClick="contextMenuClick"
            :contextMenuOpen="contextMenuOpen"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GanttComponent as EjsGantt, ContextMenu, Edit, Sort, Resize, Selection } from "@syncfusion/ej2-vue-gantt";
import { editingData } from './data-source.js';
const customContextMenu = ref(null);
const data = editingData;
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const editSettings = {
    allowAdding: true,
    allowEditing: true,
    allowDeleting: true
};
const contextMenuItems = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
    { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
    { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
    { text: 'Hide Column', target: '.e-gridheader', id: 'hidecols' }
];
const contextMenuClick = function (args) {
    var record = args.rowData;
    var ganttObj = customContextMenu.value.ej2Instances;
    if (args.item.id === 'collapserow') {
        ganttObj.collapseByID(Number(record.ganttProperties.taskId));
    }
    if (args.item.id === 'expandrow') {
        ganttObj.expandByID(Number(record.ganttProperties.taskId));
    }
    if (args.item.id === 'hidecols') {
        ganttObj.hideColumn(args.column.headerText);
    }
}
const contextMenuOpen = function (args) {
    var record = args.rowData;
    if (args.type !== 'Header') {
        if (!record.hasChildRecords) {
            args.hideItems.push('Collapse the Row');
            args.hideItems.push('Expand the Row');
        } else {
            if (record.expanded) {
                args.hideItems.push("Expand the Row");
            } else {
                args.hideItems.push("Collapse the Row");
            }
        }
    }
}
provide('gantt', [ContextMenu, Edit, Sort, Resize, Selection]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="customContextMenu" :dataSource="data" :taskFields = "taskFields" :height = "height" :editSettings="editSettings" :enableContextMenu="true" :allowSorting="true" :allowResizing= "true" :contextMenuItems="contextMenuItems" :contextMenuClick = "contextMenuClick" :contextMenuOpen="contextMenuOpen"></ejs-gantt>
    </div>
</template>
<script>
import { GanttComponent, ContextMenu, Edit, Sort, Resize, Selection } from "@syncfusion/ej2-vue-gantt";
import { editingData } from './data-source.js';
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
        data: editingData,
        height: '450px',
        taskFields: {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            child: 'subtasks'
        },
        editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true
        },
        contextMenuItems: ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
        { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
        { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
        { text: 'Hide Column', target: '.e-gridheader', id: 'hidecols' }
        ],
    };
  },
  provide: {
      gantt: [ ContextMenu, Edit, Sort, Resize, Selection]
  },
  methods: {
        contextMenuClick: function (args) {
        var record = args.rowData;
        var ganttObj = document.getElementById('customContextMenu').ej2_instances[0];
        if (args.item.id === 'collapserow') {
            ganttObj.collapseByID(Number(record.ganttProperties.taskId));
            }
        if (args.item.id === 'expandrow') {
            ganttObj.expandByID(Number(record.ganttProperties.taskId));
            }
        if (args.item.id === 'hidecols') {
            ganttObj.hideColumn(args.column.headerText);
        }
        },
        contextMenuOpen: function (args) {
        var record = args.rowData;
            if (args.type !== 'Header') {
                if (!record.hasChildRecords) {
                    args.hideItems.push('Collapse the Row');
                    args.hideItems.push('Expand the Row');
                } else {
                    if(record.expanded){
                    args.hideItems.push("Expand the Row");
                    } else {
                    args.hideItems.push("Collapse the Row");
                    }
                }
            }
        }
    }
};
</script>

You can show an specific item in context menu for header/content area in the Gantt Chart component by defining the target property.

Touch interaction

To perform long press action on a row, context menu is opened, and then tap a menu item to trigger its action.